import * as i0 from '@angular/core';
import { Component, Input, InjectionToken, Directive, Optional, Host, Inject, NgModule } from '@angular/core';
import { tap, shareReplay, takeWhile } from 'rxjs/operators';
import { fromEvent, EMPTY, merge } from 'rxjs';
import * as i1 from '@angular/forms';

class ControlErrorComponent {
    constructor(cdr) {
        this.cdr = cdr;
        this._text = '';
        this._hide = true;
    }
    set text(value) {
        // eslint-disable-next-line no-underscore-dangle
        if (value !== this._text) {
            // eslint-disable-next-line no-underscore-dangle
            this._text = value;
            // eslint-disable-next-line no-underscore-dangle
            this._hide = !value;
            this.cdr.detectChanges();
        }
    }
    ngOnInit() {
    }
}
ControlErrorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
ControlErrorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: ControlErrorComponent, selector: "app-control-error", inputs: { text: "text" }, ngImport: i0, template: "<ng-container style=\"width:100%\">\n<span class=\"sm-ng-error-message\" [class.hide]=\"_hide\">\n                                {{_text}}\n                            </span>\n</ng-container>\n", styles: [".hide{display:none;margin:0!important}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-control-error', template: "<ng-container style=\"width:100%\">\n<span class=\"sm-ng-error-message\" [class.hide]=\"_hide\">\n                                {{_text}}\n                            </span>\n</ng-container>\n", styles: [".hide{display:none;margin:0!important}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { text: [{
                type: Input
            }] } });

const defaultErrors = {
    required: () => 'This field is required',
    min: (requiredLength) => `The input should not be less than ${requiredLength}`,
    minlength: ({ requiredLength, actualLength }) => `Expected ${requiredLength} but got ${actualLength}`,
    maxlength: ({ requiredLength, actualLength }) => `Expected ${requiredLength} but got ${actualLength}`,
    email: () => 'Please enter a valid email',
    pattern: () => 'Invalid input'
};
// creating injection token to inject the form errors in runtime
const FORM_ERRORS = new InjectionToken('FORM_ERRORS');

class ControlErrorContainerDirective {
    constructor(vcr) {
        this.vcr = vcr;
    }
}
ControlErrorContainerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorContainerDirective, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive });
ControlErrorContainerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: ControlErrorContainerDirective, selector: "[controlErrorContainer]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorContainerDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[controlErrorContainer]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; } });

class FormSubmitDirective {
    constructor(host) {
        this.host = host;
        this.submit$ = fromEvent(this.element, 'submit').pipe(tap(_ => {
            if (this.element.classList.contains('sm-ng-submitted') === false) {
                this.element.classList.add('sm-ng-submitted');
            }
        }), shareReplay(1));
    }
    get element() {
        return this.host.nativeElement;
    }
}
FormSubmitDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: FormSubmitDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
FormSubmitDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: FormSubmitDirective, selector: "form", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: FormSubmitDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'form'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class ControlErrorDirective {
    constructor(controlDir, form, // to catch the form events[submit event]
    // @ts-ignore
    errors, // to get the form errors (which is either default or provided by user)
    vcr, controlErrorContainer // gives reference of the div inside which the error message needs to be displayed
    ) {
        this.controlDir = controlDir;
        this.form = form;
        this.errors = errors;
        this.vcr = vcr;
        this.customErrors = {};
        this.checkParent = false;
        this.partialCheck = false;
        this.subscriptionState = true;
        this.submit$ = this.form ? this.form.submit$ : EMPTY;
        this.container = controlErrorContainer ? controlErrorContainer.vcr : vcr;
    }
    ngOnInit() {
        // conditional check is true when the validation depends on other  controls in the  parent (eg: sale price should be less than normal price)
        const conditionalCheck = this.checkParent ? this.parentControl?.valueChanges : [];
        // @ts-ignore
        merge(this.submit$, this.control?.valueChanges, conditionalCheck).pipe(// it listens to form submit event, control changes  and conditionally the changes in parent controls
        takeWhile(() => this.subscriptionState)).subscribe(() => {
            const controlErrors = this.control?.errors || (this.checkParent ? this.parentControl?.errors : null);
            if (controlErrors) {
                let errorText;
                const keys = Object.keys(this.customErrors);
                if (keys.length > 0) {
                    for (let i = 0; i < keys.length; i++) {
                        if (controlErrors.hasOwnProperty(keys[i])) {
                            errorText = this.customErrors[keys[i]];
                            break;
                        }
                    }
                }
                let text = errorText;
                if (!errorText) {
                    const firstKey = Object.keys(controlErrors)[0];
                    const getError = this.errors[firstKey];
                    text = this.customErrors[firstKey] || (getError && getError(controlErrors[firstKey])); // if custom error  is provided it shows that error or else looks into the default errors
                }
                this.setError(text);
            }
            else if (this.ref) {
                // if ref is  set and there is no error, we remove the error
                // the ref is set once when registering the error for the  first time.
                this.setError('');
            }
        });
    }
    ngOnDestroy() {
        this.subscriptionState = false;
    }
    get control() {
        return this.controlDir.control;
    }
    // we need parent control when we have to check the validation in the parent group
    get parentControl() {
        return this.controlDir?.control?.parent;
    }
    setError(text) {
        const showError = this.form.host.nativeElement.classList.contains('sm-ng-submitted') || this.partialCheck;
        this.setErrorBorder(text, showError);
        if (!this.ref) { // if ref is not defined, we create the ref to the control error component
            this.ref = this.vcr.createComponent(ControlErrorComponent);
            const element = this.ref.location.nativeElement;
            element.style.width = '100%';
        }
        this.ref.instance['text'] = (text && showError) ? text : '';
    }
    setErrorBorder(state, showError) {
        if (state && showError) {
            this.container.element.nativeElement.classList.add('sm-ng-error');
        }
        else {
            this.container.element.nativeElement.classList.remove('sm-ng-error');
        }
    }
}
ControlErrorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorDirective, deps: [{ token: i1.NgControl }, { token: FormSubmitDirective, host: true, optional: true }, { token: FORM_ERRORS }, { token: i0.ViewContainerRef }, { token: ControlErrorContainerDirective, optional: true }], target: i0.ɵɵFactoryTarget.Directive });
ControlErrorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: ControlErrorDirective, selector: "[formControl], [formControlName]", inputs: { customErrors: "customErrors", checkParent: "checkParent", partialCheck: "partialCheck" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: ControlErrorDirective, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: '[formControl], [formControlName]'
                }]
        }], ctorParameters: function () { return [{ type: i1.NgControl }, { type: FormSubmitDirective, decorators: [{
                    type: Optional
                }, {
                    type: Host
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [FORM_ERRORS]
                }] }, { type: i0.ViewContainerRef }, { type: ControlErrorContainerDirective, decorators: [{
                    type: Optional
                }] }]; }, propDecorators: { customErrors: [{
                type: Input
            }], checkParent: [{
                type: Input
            }], partialCheck: [{
                type: Input
            }] } });

const SM_FORM_VALIDATION_CONFIG = new InjectionToken('SM_FORM_VALIDATION_CONFIG');

// @ts-ignore
class SmFormValidationModule {
    static forRoot(config) {
        if (config && config.hasOwnProperty('errorColor')) {
            const root = document.querySelector(':root');
            // @ts-ignore
            root.style.setProperty('--sm-validation-error-color', config.errorColor);
        }
        return {
            ngModule: SmFormValidationModule,
            // conditionally setting the error messages in runtime
            providers: [{
                    provide: FORM_ERRORS,
                    useFactory: () => ({ ...defaultErrors, ...(config && hasErrorMessages(config.defaultErrors) && config.defaultErrors) })
                }]
        };
    }
}
SmFormValidationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SmFormValidationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SmFormValidationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: SmFormValidationModule, declarations: [ControlErrorComponent,
        ControlErrorDirective,
        ControlErrorContainerDirective,
        FormSubmitDirective], exports: [ControlErrorComponent,
        ControlErrorDirective,
        ControlErrorContainerDirective,
        FormSubmitDirective] });
SmFormValidationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SmFormValidationModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: SmFormValidationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ControlErrorComponent,
                        ControlErrorDirective,
                        ControlErrorContainerDirective,
                        FormSubmitDirective
                    ],
                    imports: [],
                    exports: [
                        ControlErrorComponent,
                        ControlErrorDirective,
                        ControlErrorContainerDirective,
                        FormSubmitDirective
                    ]
                }]
        }] });
function hasErrorMessages(obj) {
    if (!obj) {
        return false;
    }
    if (isNotEmpty(obj)) {
        return true;
    }
    return false;
}
function isNotEmpty(object) {
    // @ts-ignore
    return Object.values(object).some(x => (x !== undefined && x !== null && x !== ''));
}

/*
 * Public API Surface of sm-form-validation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ControlErrorComponent, ControlErrorContainerDirective, ControlErrorDirective, FORM_ERRORS, FormSubmitDirective, SM_FORM_VALIDATION_CONFIG, SmFormValidationModule, defaultErrors };
//# sourceMappingURL=sm-ng-form-validation.mjs.map
