import { ComponentRef, OnDestroy, OnInit, ViewContainerRef } from '@angular/core';
import { NgControl } from '@angular/forms';
import { Observable } from 'rxjs';
import { ControlErrorComponent } from '../components';
import { ControlErrorContainerDirective } from './control-error-container.directive';
import { FormSubmitDirective } from './form-submit.directive';
import * as i0 from "@angular/core";
export declare class ControlErrorDirective implements OnInit, OnDestroy {
    private controlDir;
    private form;
    private errors;
    private vcr;
    customErrors: any;
    checkParent: boolean;
    partialCheck: boolean;
    ref: ComponentRef<ControlErrorComponent>;
    container: ViewContainerRef;
    submit$: Observable<Event>;
    private subscriptionState;
    constructor(controlDir: NgControl, form: FormSubmitDirective, // to catch the form events[submit event]
    errors: any, // to get the form errors (which is either default or provided by user)
    vcr: ViewContainerRef, controlErrorContainer: ControlErrorContainerDirective);
    ngOnInit(): void;
    ngOnDestroy(): void;
    get control(): import("@angular/forms").AbstractControl<any, any> | null;
    get parentControl(): import("@angular/forms").FormGroup<any> | import("@angular/forms").FormArray<any> | null | undefined;
    private setError;
    private setErrorBorder;
    static ɵfac: i0.ɵɵFactoryDeclaration<ControlErrorDirective, [null, { optional: true; host: true; }, null, null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ControlErrorDirective, "[formControl], [formControlName]", never, { "customErrors": "customErrors"; "checkParent": "checkParent"; "partialCheck": "partialCheck"; }, {}, never, never, false>;
}
